#include "Python.h"
#include "pythread.h"

PyThread_type_lock lock;

void tproc(void* arg)
{
    PyGILState_STATE state;

    // Uncomment to avoid crash
    //PyInterpreterState *istate = PyInterpreterState_Head();
    //PyThreadState *tstate = PyThreadState_New(istate);

    state = PyGILState_Ensure();

    if (!PyGILState_Check())
        abort();

    PyGILState_Release(state);

    PyThread_release_lock(lock);

    PyThread_exit_thread();
}

int main() {
    long thrd;
    PyGILState_STATE state;

    lock = PyThread_allocate_lock();

    Py_Initialize();
    // Uncomment to avoid crash
    //PyEval_InitThreads();

    thrd = PyThread_start_new_thread(tproc, NULL);
    PyThread_acquire_lock(lock, WAIT_LOCK);

    Py_BEGIN_ALLOW_THREADS
    /* wait until the thread exit */
    PyThread_acquire_lock(lock, WAIT_LOCK);
    Py_END_ALLOW_THREADS

    PyThread_free_lock(lock);

    return 0;
}
